#ifndef _VPWBLPR_C
#define _VPWBLPR_C
//----------------------------------------------------------------------
// vpwblpr.c _VPW_VERSIONSTRING
// (c) copyright Enrico Sorichetti, 2004-2007
// Released under the "Q Public license"
//----------------------------------------------------------------------
//

#undef	_VPW_MAIN

#include "vpwpc.h"

#include "blklet2.h"
#include "blklet3.h"

#include "blknum2.h"
#include "blknum3.h"

#include "blkmsc2.h"
#include "blkmsc3.h"

void vpwblpr(const int slant, const int count, const char *chars )
{
	int i, j, l;
	int c ;

 	char	*blklett;	
 	char	*blknumb;
 	char	*blkmisc;

	switch ( stdwidth ) {
		case _VPW_2CHARS:
			blklett = ( char * ) &blklet2;
			blknumb = ( char * ) &blknum2;	
			blkmisc = ( char * ) &blkmsc2;	
			break ;	 
		case _VPW_3CHARS:
 			blklett = ( char * ) &blklet3;
 			blknumb = ( char * ) &blknum3;	
  			blkmisc = ( char * ) &blkmsc3;	
			break;		
	}          

	char blanks[_VPW_CHARS257];
	for ( i=0; i < _VPW_CHARS257 - 1 ; blanks[i++]=' ');
	blanks[i] ='\0';

	int size ;
	int offs, decr;

	int row,col ;

	size = ( count * ( _VPW_BLKWIDTH + _VPW_GAPWIDTH) ) - _VPW_GAPWIDTH;
	size = size + slant * ( _VPW_BLKWIDTH - 1 );

	offs = ( _VPW_LNLENGTH - size ) / 2 ;
	offs = offs + slant * ( _VPW_BLKWIDTH - 1 );

	decr = slant * 1 ;
							
	for ( i  = 0; i  < _VPW_BLHEIGHT; i ++ , offs -= decr ) {

		for ( j = 0; j < ( offs - _VPW_GAPWIDTH ) ; blkstak[i][j++] = ' ') ;
		blkstak[i][j] ='\0' ;

		for ( c = 0; c < count; c++) {

            strncat(blkstak[i], blanks, _VPW_GAPWIDTH ) ;

            if (chars[c] >= '0' && chars[c] <= '9') {
				row = i  + ( (chars[c] - '0') * _VPW_BLKWIDTH )  ;
				strncat ( blkstak[i ], blknumb + row*(_VPW_BLKWIDTH + 1 ) , _VPW_BLKWIDTH ) ;
			}

			else \
            if (chars[c] >= 'A' && chars[c] <= 'Z')	{
				row = i  + ( (chars[c] - 'A') * _VPW_BLKWIDTH)  ;
 				strncat ( blkstak[i ], blklett + row*(_VPW_BLKWIDTH + 1 ) , _VPW_BLKWIDTH ) ;
			}
			
#if 0
			else \
            if ( ... )	{
				row = i  + ( (chars[c] - 'A') * _VPW_BLKWIDTH)  ;
				strncat ( blkstak[i ], blkmisc + row*(_VPW_BLKWIDTH + 1) , _VPW_BLKWIDTH ) ;
			}
#endif
			else {
				strncat ( blkstak[i], blanks, _VPW_BLKWIDTH ) ;
			}

		}
	}

    return ;

}

#endif
